Loading...
Searching...
No Matches
ReadAccessor< BuildT, LEVEL0, -1, -1 > Class Template Reference

Node caching at a single tree level. More...

`#include <nanovdb/NanoVDB.h>`

## Public Types

using | BuildType = BuildT
using | ValueType = ValueT
using | CoordType = CoordT

## Public Member Functions

| ReadAccessor (const RootT &root)
| Constructor from a root node.
| ReadAccessor (const GridT &grid)
| Constructor from a grid.
| ReadAccessor (const TreeT &tree)
| Constructor from a tree.
void | clear ()
| Reset this access to its initial state, i.e. with an empty cache.
const RootT & | root () const
| ReadAccessor (const ReadAccessor &)=default
| Defaults constructors.
| ~ReadAccessor ()=default
ReadAccessor & | operator= (const ReadAccessor &)=default
bool | isCached (const CoordType &ijk) const
ValueType | getValue (const CoordType &ijk) const
ValueType | getValue (int i, int j, int k) const
ValueType | operator() (const CoordType &ijk) const
ValueType | operator() (int i, int j, int k) const
auto | getNodeInfo (const CoordType &ijk) const
bool | isActive (const CoordType &ijk) const
bool | probeValue (const CoordType &ijk, ValueType &v) const
const LeafT * | probeLeaf (const CoordType &ijk) const
template<typename RayT >
uint32_t | getDim (const CoordType &ijk, const RayT &ray) const
template<typename OpT , typename... ArgsT>
auto | get (const CoordType &ijk, ArgsT &&... args) const
template<typename OpT , typename... ArgsT>
auto | set (const CoordType &ijk, ArgsT &&... args) const

## Static Public Attributes

static const int | CacheLevels = 1

## Friends

template<typename >
class | RootNode
| Allow nodes to insert themselves into the cache.
template<typename , uint32_t >
class | InternalNode
template<typename , typename , template< uint32_t > class, uint32_t >
class | LeafNode

## Detailed Description

template<typename BuildT, int LEVEL0>
class nanovdb::ReadAccessor< BuildT, LEVEL0, -1, -1 >

Node caching at a single tree level.

## Member Typedef Documentation

## BuildType

template<typename BuildT , int LEVEL0>

using BuildType = BuildT

## CoordType

template<typename BuildT , int LEVEL0>

using CoordType = CoordT

## ValueType

template<typename BuildT , int LEVEL0>

using ValueType = ValueT

## Constructor & Destructor Documentation

## ReadAccessor() [1/4]

template<typename BuildT , int LEVEL0>

ReadAccessor | ( | const RootT & | root | ) |

inline

Constructor from a root node.

## ReadAccessor() [2/4]

template<typename BuildT , int LEVEL0>

ReadAccessor | ( | const GridT & | grid | ) |

inline

Constructor from a grid.

## ReadAccessor() [3/4]

template<typename BuildT , int LEVEL0>

ReadAccessor | ( | const TreeT & | tree | ) |

inline

Constructor from a tree.

## ReadAccessor() [4/4]

template<typename BuildT , int LEVEL0>

ReadAccessor | ( | const ReadAccessor< BuildT, LEVEL0, -1, -1 > & |  | ) |

default

Defaults constructors.

## ~ReadAccessor()

template<typename BuildT , int LEVEL0>

~ReadAccessor | ( |  | ) |

default

## Member Function Documentation

## clear()

template<typename BuildT , int LEVEL0>

void clear | ( |  | ) |

inline

Reset this access to its initial state, i.e. with an empty cache.

## get()

template<typename BuildT , int LEVEL0>
template<typename OpT , typename... ArgsT>

auto get | ( | const CoordType & | ijk,
|  | ArgsT &&... | args ) const

inline

## getDim()

template<typename BuildT , int LEVEL0>
template<typename RayT >

uint32_t getDim | ( | const CoordType & | ijk,
|  | const RayT & | ray ) const

inline

## getNodeInfo()

template<typename BuildT , int LEVEL0>

auto getNodeInfo | ( | const CoordType & | ijk | ) | const

inline

## getValue() [1/2]

template<typename BuildT , int LEVEL0>

ValueType getValue | ( | const CoordType & | ijk | ) | const

inline

## getValue() [2/2]

template<typename BuildT , int LEVEL0>

ValueType getValue | ( | int | i,
|  | int | j,
|  | int | k ) const

inline

## isActive()

template<typename BuildT , int LEVEL0>

bool isActive | ( | const CoordType & | ijk | ) | const

inline

## isCached()

template<typename BuildT , int LEVEL0>

bool isCached | ( | const CoordType & | ijk | ) | const

inline

## operator()() [1/2]

template<typename BuildT , int LEVEL0>

ValueType operator() | ( | const CoordType & | ijk | ) | const

inline

## operator()() [2/2]

template<typename BuildT , int LEVEL0>

ValueType operator() | ( | int | i,
|  | int | j,
|  | int | k ) const

inline

## operator=()

template<typename BuildT , int LEVEL0>

ReadAccessor & operator= | ( | const ReadAccessor< BuildT, LEVEL0, -1, -1 > & |  | ) |

default

## probeLeaf()

template<typename BuildT , int LEVEL0>

const LeafT * probeLeaf | ( | const CoordType & | ijk | ) | const

inline

## probeValue()

template<typename BuildT , int LEVEL0>

bool probeValue | ( | const CoordType & | ijk,
|  | ValueType & | v ) const

inline

## root()

template<typename BuildT , int LEVEL0>

const RootT & root | ( |  | ) | const

inline

## set()

template<typename BuildT , int LEVEL0>
template<typename OpT , typename... ArgsT>

auto set | ( | const CoordType & | ijk,
|  | ArgsT &&... | args ) const

inline

## Friends And Related Symbol Documentation

## InternalNode

template<typename BuildT , int LEVEL0>
template<typename , uint32_t >

friend class InternalNode

friend

## LeafNode

template<typename BuildT , int LEVEL0>
template<typename , typename , template< uint32_t > class, uint32_t >

friend class LeafNode

friend

## RootNode

template<typename BuildT , int LEVEL0>
template<typename >

friend class RootNode

friend

Allow nodes to insert themselves into the cache.

## Member Data Documentation

## CacheLevels

template<typename BuildT , int LEVEL0>

const int CacheLevels = 1

static